clear
load zz.mat


%read the image and convert it to double type with range from 0 and 1
img = im2double(imread('lena.jpg'));

[row,col] = size(img); %get the number of rows and columns for the image

K = [1 4 8 16 24 32 40 48 64];

rstimg = zeros(size(img)); %store the reconstruction of the image 
mse = zeros(1,length(K)); %store the MSE for each k in K
%for each k compute the the DCT, compress and reconstruct
for i = 1:length(K)
    k=K(i);
	rstimg = zeros(size(img)); %store the reconstruction of the image 
    for p = 0:floor(row/8)-1
        for q = 0:floor(col/8)-1
            %get a 8x8 image block for DCT 
            block = img(p*8+1:p*8+8,q*8+1:q*8+8);
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %compute the 8x8 DCT of the block using dct2
            dctblock =  %introduce your code here%  ;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            %set the coefficients of with higher ranking to zero.
            cmp = dctblock.*(zz<=k);
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %reconstruct the block from the compressed DCT coefficients(cmp)
            %using commend idct2
            recblock =   %introduce your code here% ;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            %put the reconstructed block into the result image (rstimg)
            rstimg(p*8+1:p*8+8,q*8+1:q*8+8) = recblock;
        end
    end
    %display the image
    figure(1);subplot(3,3,i);imshow(rstimg);title([int2str(k)]);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %compute the MSE between the two images (img and rstimg)
    mse(i) =   %introduce your code here% ; 
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
%display the curve of MSE
figure(2);plot(K,mse, 'bo-');

